Index: branches/encoders/code/projects/libdragonfly/lights.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/lights.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/lights.c	(revision 1345)
@@ -260,124 +523,235 @@
  *
  * @see orb_init
  **/
-void orb1_set(unsigned char red_led, unsigned char green_led, unsigned char blue_led) {
-	orb_set_angle(0,red_led);
-	orb_set_angle(1,green_led);
-	orb_set_angle(2,blue_led);
+void orb2_set (uint8_t red, uint8_t green, uint8_t blue) {
+	REQUIRE_LOCK_OR_RETURN(orb_lock);
+	
+    set_orb_values (1, red, green, blue);
+    apply_orbs ();
+
+	RELEASE_LOCK(orb_lock);
 }
 
 /**
- * Set orb2 to the color specified. orb_init must
- * be called before this function may be used.
+ * Set both orbs to the color specified. The orbs must be initialized before this function may be used.
  *
  * @param red_led the red component of the color
  * @param green_led the green component of the color
  * @param blue_led the blue component of the color
  *
- * @see orb_init
+ * @see orb_init, orb1_set, orb2_set
  **/
-void orb2_set(unsigned char red_led, unsigned char green_led, unsigned char blue_led) {	
-	orb_set_angle(4,red_led);
-	orb_set_angle(5,green_led);
-	orb_set_angle(6,blue_led);
+void orb_set (uint8_t red, uint8_t green, uint8_t blue) {
+	REQUIRE_LOCK_OR_RETURN(orb_lock);
+	
+    set_orb_values (0, red, green, blue);
+    set_orb_values (1, red, green, blue);
+    apply_orbs ();
+
+	RELEASE_LOCK(orb_lock);
 }
 
 /**
- * Set both orbs to the specified color. This function
- * is intended to be used with the predefined
- * colors. orb_init must be called before this
- * function may be used.
+ * Set the orbs to the respective values. The orbs must be initialized before this function may be used. Note that, when
+ * setting both orbs, this function is faster than calling orb1_set and orb2_set (or orb_n_set) because the values are
+ * only sorted once.
  *
- * @param col the color to set the orbs to
- *
- * @see orb_init
+ * @param red1
+ * @param green1
+ * @param blue1
+ * @param red2
+ * @param green2
+ * @param blue2
+ * @see orb1_set
+ * @see orb2_set
+ * @see orb_n_set
  **/
-void orb_set_color(int col)
-{
- int red, green, blue;
+void orbs_set (
+    uint8_t red1, uint8_t green1, uint8_t blue1,
+    uint8_t red2, uint8_t green2, uint8_t blue2) {
 
- red = ((col & 0xE0) >> 5) * 36;
- green = ((col & 0x1C) >> 2) * 36;
- blue = (col & 0x03) * 85;
+	REQUIRE_LOCK_OR_RETURN(orb_lock);
 
- orb_set(red, green, blue);
+    set_orb_values (0, red1, green1, blue1);
+    set_orb_values (1, red2, green2, blue2);
+    apply_orbs ();
+
+	RELEASE_LOCK(orb_lock);
 }
 
+
+// ******************************
+// ** Predefined color setting **
+// ******************************
+
+// This functions just call the corresponding orb*_set functions. If the orbs array is accessed in any other way, it
+// must be synchronized on orb_lock (REQUIRE_LOCK_OR_RETURN and RELEASE_LOCK)! Note that one synchronized function
+// cannot call another one with this lock implementation.
+
+// Macros for extracting a color.
+#define C_RED(col)   (((col & 0xE0) >> 5) * 36)
+#define C_GREEN(col) (((col & 0x1C) >> 2) * 36)
+#define C_BLUE(col)  (((col & 0x03)     ) * 85)
+
 /**
- * Set orb1 to the specified color. This function
- * is intended to be used with the predefined
- * colors. orb_init must be called before this
- * function may be used.
+ * Set the specified orb to the specified color. This function is intended to be used with the predefined colors.
  *
+ * @param num the number of the orb to set (0 or 1)
  * @param col the color to set the orbs to
+ **/
+void orb_n_set_color(uint8_t num, uint8_t col) {
+    orb_n_set(num, C_RED(col), C_GREEN(col), C_BLUE(col));
+}
+
+/**
+ * Set orb1 to the specified color. This function is intended to be used with the predefined colors.
  *
- * @see orb_init
+ * @param col the color to set the orbs to
  **/
-void orb1_set_color(int col)
-{
- int red, green, blue;
+void orb1_set_color(uint8_t col) {
+    orb1_set (C_RED(col), C_GREEN(col), C_BLUE(col));
+}
 
- red = ((col & 0xE0) >> 5) * 36;
- green = ((col & 0x1C) >> 2) * 36;
- blue = (col & 0x03) * 85;
-
- orb1_set(red, green, blue);
+/**
+ * Set orb2 to the specified color. This function is intended to be used with the predefined colors.
+ *
+ * @param col the color to set the orbs to
+ **/
+void orb2_set_color(uint8_t col) {
+    orb2_set(C_RED(col), C_GREEN(col), C_BLUE(col));
 }
 
 /**
- * Set orb2 to the specified color. This function
- * is intended to be used with the predefined
- * colors. orb_init must be called before this
- * function may be used.
+ * Set both orbs to the specified color. This function is intended to be used with the predefined colors.
  *
  * @param col the color to set the orbs to
+ **/
+void orb_set_color(uint8_t col) {
+    orb_set (C_RED(col), C_GREEN(col), C_BLUE(col));
+}
+
+/**
+ * Set the orbs to the respective color. This function is intended to be used with the predefined colors.
  *
- * @see orb_init
+ * @param col1 the color to set orb 1 to
+ * @param col2 the color to set orb 2 to
  **/
-void orb2_set_color(int col)
-{
- int red, green, blue;
+void orbs_set_color(uint8_t col1, uint8_t col2) {
+    orbs_set (C_RED(col1), C_GREEN(col1), C_BLUE(col1), C_RED(col2), C_GREEN(col2), C_BLUE(col2));
+}
 
- red = ((col & 0xE0) >> 5) * 36;
- green = ((col & 0x1C) >> 2) * 36;
- blue = (col & 0x03) * 85;
+#undef C_BLUE
+#undef C_GREEN
+#undef C_RED2
 
- orb2_set(red, green, blue);
+
+// ******************
+// ** Mode setting **
+// ******************
+
+/**
+ * Enables the orb timer. Note that you usually don't want to use this function directly. Instead, use orb_set_mode.
+ * @see orb_set_mode
+ **/
+void orb_enable_timer (void) {
+    // Use 8 bit TC0.
+    //
+    // Timer mode: We cannot use CTC mode because it can only clear on OCR0 (in contrast to the 16 bit timers which can
+    // also use the ICR for that) and OCR0 is already used for generating output compare interrupts. We also need
+    // immediate (non double buffered) update of OCR0, so the only mode left is "Normal".
+    //
+    // Note that for a timer counting from 0 to 255, there are 256 states and thus 257 output possibilities
+    // (0/256...256/256)! However, there are only 256 values in the byte used to specify the PWM value. Possible ways
+    // to deal with that:
+    //   1. use a 16 bit variable for the PWM value (memory waste, overhead)
+    //   2. use an additional flag for the 257th value (inconvenient)
+    //   3. use 1/256...256/256 (skip 0, never complete off)
+    //   4. use 0/256...256/256 (skip 256, never complete on)
+    //   5. skip a value somewhere in the middle
+    //   6. reload the timer after 254
+    // For this implementation, variant 4 was chosen.
+    //
+    // Using an 8 bit timer has the added advantage that all the comparisons are faster.
+    
+    // Normal mode, Compare match output off, Prescaler
+    TCCR0=_BV(CS02) | _BV(CS01); // 256, 120 Hz
+
+    // Enable the interrupts
+    TIMSK|= _BV(OCIE0) | _BV(TOIE0);
 }
 
-//DOES THIS WORK?
-// Disables the timer1 interrupt, disabling the Orb's color fading capabilities
-// You can still turn the red, green, and blue leds on and off with set_orb_dio
-/* If we use the PWM for anything else besides the ORB, this implementation needs to be done better */
 /**
- * Disables the orb color fading capabilities
- * by disabling the timer1 interrupt.
- *
- * @see orb_init
+ * Disables the orb timer. Note that you usually don't want to use this function directly. Instead, use orb_set_mode.
+ * @see orb_set_mode
  **/
-void orb_disable()
-{
-	TCCR3B &= 0;  	//Turn off everything
-	ORB_PORT |= _BV(ORB1_RED);
-	ORB_PORT |= _BV(ORB1_GREEN);
-	ORB_PORT |= _BV(ORB1_BLUE);
-	ORB_PORT |= _BV(ORB2_RED);
-	ORB_PORT |= _BV(ORB2_GREEN);
-	ORB_PORT |= _BV(ORB2_BLUE);
+void orb_disable_timer (void) {
+    // Disable the interrupts
+    TIMSK&=~( _BV(OCIE0) | _BV(TOIE0));
 }
 
-//DOES THIS WORK?
-// Enables the timer1 interrupt, enabling the Orb's color fading capabilities
+
+void orb_set_mode (orb_mode_t mode) {
+    // Set enable_orb_pwm to the appropriate value and disable or enable the timer.
+    if (mode==orb_mode_binary) {
+        orb_disable_timer ();
+
+        enable_orb_pwm=false;
+        apply_orbs ();
+    }
+    else { // orb_mode_pwm
+        enable_orb_pwm=true;
+        apply_orbs ();
+
+        orb_enable_timer ();
+    }
+}
+
+
+// ********************
+// ** Initialization **
+// ********************
+
+// Orb initialization code common to all modes.
+static void orb_init_common (void) {
+    // Enable the output ports and turn off the LEDs
+    ORBPORT |=  all_orbs_mask;
+    ORBDDR  |=  all_orbs_mask;
+
+    // Set all orbs to "off"
+    orb_set (0, 0, 0);
+    
+#ifdef LIGHTS_DEBUG
+    LIGHTS_DEBUG_INIT
+#endif
+}
+
 /**
- * Enables the orb's color fading capabilities.
- *
- * @see orb_init
+ * Initializes the orbs in PWM mode. One of the orb_init* functions must be called before the orbs can be used.
+ * 
+ * @see orb_init_pwm
  **/
-void orb_enable()
-{
-//	TCCR0 |= _BV(COM01) | _BV(COM00)  | _BV(WGM00) | _BV(CS01);	//Toggle OC Pin on match, FAST PWM Mode, clock/8
-	TCCR3B =_BV(CS31);
+void orb_init_binary (void) {
+    orb_init_common ();
+    orb_set_mode (orb_mode_binary);
 }
 
-/** @} **/ //end group
+/**
+ * Initializes the orbs in PWM mode. One of the orb_init* functions must be called before the orbs can be used.
+ * 
+ * @see orb_init_binary
+ **/
+void orb_init_pwm (void) {
+    orb_init_common ();
+    orb_set_mode (orb_mode_pwm);
+}
 
+/**
+ * Initializes the orbs in default mode. One of the orb_init* functions must be called before the orbs can be used. Use
+ * the orb_init_binary or orb_init_pwm function if you want one specific mode.
+ *
+ * @see orb_init_pwm
+ * @see orb_init_binary
+ **/
+void orb_init () {
+    orb_init_pwm ();
+}
Index: branches/encoders/code/projects/libdragonfly/ring_buffer.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/ring_buffer.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/ring_buffer.h	(revision 1345)
@@ -1,12 +1,39 @@
-/** @file Include macros to create a ring buffer. Originally written for 15-410.
- *  Modified for use in ATMega128 serial driver
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/** @file ring_buffer.h
+ * @brief Ring Buffer
  *
- *	@author Cornell Wright (cgwright)
- *	@author Jason P. Winters (jpwinter)
+ * Include macros to create a ring buffer. Originally written for 15-410.
+ * Modified for use in ATMega128 serial driver
  *
- *	@bugs Could not create buffer of non byte-sized elements due to modding with sizeof(queue).  
- * 		  Fixed 3/2/07, Felix Duvallet and Brad Neuman
- */
+ * @author Cornell Wright (cgwright)
+ * @author Jason P. Winters (jpwinter)
+ *
+ **/
 
 #ifndef _RING_BUFFER_H
 #define _RING_BUFFER_H
